10 '--------ADD1RTC.bas----------------------------
20 '-----READ DS3231 RTC Time/Date and ADD + 1 Hour to the DS3231 RTC
30 'Author: Hacker - DuinoMiteAndy
40 'Date: 17/12/2011
50 'Version: Rev. 1.0b
60 'MMBasic Firmware: 2.7 DuinoMite Mega
70 'Platform: Win XP/SP3
80 'Credits: CrackerJack 
90 '
100 ' --------------Code Begin--------------------
110 DIM RTCbuff(8)
120 I2Caddr = &h68 ' DS3231/DS1307 I2C address (dec 104)
130 I2CEN 100,100  ' Enable I2C 400 Khz 100 ms timeout 
140 I2CRCV I2Caddr, 0, 8, RTCbuff(0), 1, 0 ' 
150 I2CDIS
160 '
170 BCDTEMP = RTCBuff(0) 'secs (00-59)
180 BCD_Secs = RTCBuff(0) 
190 GOSUB 720
200 sec$ = STR$(decimal)
210 '
220 BCDTEMP = RTCBuff(1) ' mins (00-59)
230 BCD_Mins = RTCBuff(1)
240 GOSUB 720
250 min$ = STR$(decimal)
260 '
270 BCDTEMP = RTCBuff(2) ' hours (00-23) --> In military time!  
280 GOSUB 720
290 oldhour = decimal
300 IF decimal = 23 THEN decimal = 0:  GOTO 330' ADD +1 to military time
310 IF decimal >= 0 AND  decimal < 23  THEN decimal = decimal + 1:GOTO 330' ADD +1 to military time
311 '
320 END
330 hrs$ = STR$(decimal)
340 GOSUB 780 ' convert to dec back to bcd
350 BCD_HRS = BCD
360 '
370 t$ = hrs$+":"+min$+":"+sec$ ' <---- Update time variable                  
380 '
390 BCDTEMP = RTCBuff(3) ' dow - day of week (1-7)  Sunday = 1
400 BCD_DOW = RTCBuff(3)
410 GOSUB 720
420 dow$ = STR$(decimal)
430 '
440 BCDTEMP = RTCBuff(4) ' date --> day of month (01-31)
450 BCD_date = RTCBuff(4)
460 GOSUB 720
470 day$ = STR$(decimal)
480 '
490 BCDTEMP = RTCBuff(5) ' month - (01-12)
500 BCD_month = RTCBuff(5)
510 GOSUB 720
520 month$ = STR$(decimal)
530 '
540 BCDTEMP = RTCBuff(6) ' year - (00-99) Needs + 2000
550 BCD_Year = RTCBuff(6)  
560 GOSUB 720
570 decimal = decimal + 2000 ' adjust year + 2000
580 year$ = STR$(decimal)
590 '
600 d$ = day$+"-"+month$+"-"+year$ ' <---- Update date (day/month/year + 2000)
610 '                
620 I2Caddr = &h68 ' DS3231/DS1307 I2C address (dec 104)
630 I2CEN 400,100  ' Enable I2C 400 Khz 100 ms timeout  
640 I2CSEND I2Caddr, 0, 8, &h0, BCD_Secs,BCD_Mins,BCD_Hrs,BCD_DOW,BCD_Date,BCD_Month,BCD_Year
650 I2CDIS
660 '                
670 ? "DS3231 [Spring Forward] +1 HR ",T$                
680 ? "DS3231 Date No Change         ",D$
690 INPUT "Hit CR To Continue "; Query$ 
700 CLS
710 RUN "B:TD_R1.BAS" ' Back to Time Date utility menu
715 END                 
720 ' --- Convert BCD to Decimal -----
740 Decimal = FIX(BCDTemp / 16) * 10
750 Decimal = Decimal + (BCDTEMP AND &hF)
760 RETURN
770 ' -----GOSUB Convert Decimal to BCD HEX --------------
780 BCD = FIX(Decimal/ 10) * 16
790 BCD = BCD OR ((Decimal / 10) - (FIX(Decimal / 10))) * 10
800 RETURN
810 '                                 
