10 '--------ASRTC_R1.bas----------------------------
20 '-------- Auto Set RTC From PIC32 to DS3231/DS1307 Time/DOW/Date-------
30 'Author: Hacker - DuinoMiteMegaAndy
40 'Date: 17/12/2011
50 'Version: Rev. 1.0b
60 'MMBasic Firmware: 2.7 DuinoMite Mega
70 'Platform: Win XP/SP3
80 'Credits: CrackerJack 
90 '
100 ' --------------Code Begin--------------------
110 'Get time from PIC32 time$ and date$ and save to DS3231 RTC
120 tempdec = VAL(LEFT$(TIME$, 2))
130 GOSUB 640
140 hours = hex
150 tempdec = VAL(MID$(TIME$, 4, 2))
160 GOSUB 640
170 minutes = hex
180 tempdec = VAL(RIGHT$(TIME$, 2))
190 GOSUB 640
200 seconds = hex
210 tempdec = VAL(LEFT$(DATE$, 2))
220 DOW_DAY = tempdec 
230 GOSUB 640
240 day = hex
250 tempdec = VAL(MID$(DATE$, 4, 2))
260 DOW_MONTH = tempdec
270 GOSUB 640
280 month = hex
290 tempdec = (VAL(RIGHT$(DATE$, 4)) - 2000)
300 DOW_YEAR = tempdec
310 GOSUB 640
320 year = hex
330 rtcctrl = &h10
340 a = (14 - dow_month) / 12
350 a = FIX(a)
360 y = dow_year - a
370 y = FIX(y)
380 m = dow_month + (12 * a) - 2
390 m = FIX(m)
400 d = ((dow_day + y) + FIX(y / 4) - FIX(y / 100) + FIX(y / 400) + FIX((31 * m) / 12)) 
410 DOW = d MOD 7
420 DOW = DOW + 1 ' offset for DS3231/DS1307 RTC --> Sun(1)Mon(2)Tue(3)Wed(4)Thu(5)Fri(6)Sat(7)
430 tempdec = DOW ' DOW dec
440 GOSUB 640 ' convert to hex BCD
450 rtcwday = hex
460 ' Write Time to RTC
470 i2caddr = &h68 ' DS3231 I2C address
480 I2CEN 400,100 ' Enable I2C
490 I2CSEND i2caddr, 0, 8, &h0, seconds, minutes, hours, rtcwday, day, month, year 
500 I2CDIS
510 IF DOW = 1 THEN dow$ = "Sunday    "
520 IF DOW = 2 THEN dow$ = "Monday    "
530 IF DOW = 3 THEN dow$ = "Tuesday   "
540 IF DOW = 4 THEN dow$ = "Wednesday "
550 IF DOW = 5 THEN dow$ = "Thursday  "
560 IF DOW = 6 THEN dow$ = "Friday    "
570 IF DOW = 7 THEN dow$ = "Saturday  "
580 ? "0=ok 1=nack 2=timeout"; MM.I2C 
590 ? "DS3231 RTC has been set to ";TIME$;" ";DATE$;" ";DOW$;DOW
600 INPUT "Hit CR To Continue "; Query$
610 CLS
620 RUN "b:TD_R1.bas" 
630 END
640 '------Convert to Hex--------------
650 hex = FIX(tempdec / 10) * 16
660 hex = hex OR ((tempdec / 10) - (FIX(tempdec / 10))) * 10
670 RETURN
680 '                                            
