10 ' -------AUTORUN.BAS-----------
20 '-----On Manual Reset OR Power On Reset this file will run.----------------
30 'Author: Hacker - DuinoMiteMegaAndy
40 'Date: 17/12/2011
50 'Version: Rev. 1.0b
60 'MMBasic Firmware: 2.7 DuinoMite Mega
70 'Platform: Win XP/SP3
80 ' 
90 '------------------OPTIONS------------------------
100 '
110 '-----------Set Programmable Function Keys Options----
120 OPTION F1 "HELP"+CHR$(13)
130 OPTION F2 "SAVE"+CHR$(13)
140 OPTION F3 "LIST"+CHR$(13)
150 OPTION F4 "EDIT "
160 OPTION F5 "RUN "+CHR$(34)
170 OPTION F6 "SAVE "+CHR$(34)
180 OPTION F7 "LIST "
190 OPTION F8 "PRINT "
200 OPTION F9 "IF "
210 OPTION F10 "ENDIF"
220 OPTION F11 "FOR "
230 OPTION F12 "NEXT "
240 '
250 '-----------Drive Option--------------------
260 'Set the prompt to show the current directory
270 OPTION PROMPT CWD$ + "> "
280 '-------------------------------------------
290 '
300 '-----------Array Option---------------------
310 OPTION BASE 0 ' Default
320 '--------------------------------------------
330 '
340 '-----------Error Option---------------------
350 OPTION ERROR ABORT 'Default - For SD errors only
360 '--------------------------------------------
370 '
380 '---------------Print System Status-----------
390 ? "" 'LF 
400 ? TAB(5);"PIC32 Time ",TIME$," <----<<<<"
410 ? TAB(5);"PIC32 Date ",DATE$," <----<<<<"
420 ? TAB(5);"Loss of Power, which caused a POR (Power on reset) or a manual" 
430 ? TAB(5);"pushbutton reset has just occurred!"
440 ? TAB(5);"The PIC32 Time and Date will be restored by the battery back-up"
450 ? TAB(5);"DS3231 precision RTC"
460 ? "" ' LF 
470 ? TAB(5);"Memory ... "
480 MEMORY
490 ? TAB(5);"Copywrite ",COPYWRITE
500 ? TAB(5);"Current Default Drive ",MM.DRIVE$
510 ? TAB(5);"Current Default File ",MM.FNAMES$
520 ? TAB(5);"MM.Version ", MM.VER
530 ? TAB(5);"Hor. Resol. ",MM.HRES
540 ? TAB(5);"Ver. Resol. ",MM.VRES
550 '---------------------------------------------
560 '
570 '===========================================================================
580 'Update PIC32 RTC <-Enable AFTER DS3231 RTC has been installed and configured!
590 '===========================================================================
600 DIM RTCBuff(8)
610 I2Caddr = &h68 ' DS3231/DS1307 I2C address (dec 104)
620 I2CEN 400,100  ' Enable I2C 400 Khz 100 ms timeout 
630 I2CRCV I2Caddr, 0, 8, RTCbuff(0), 1, 0 ' 
640 I2CDIS
650 '
660 BCDTEMP = RTCBuff(0) 'secs (00-59)
670 GOSUB 1140
680 sec$ = STR$(decimal)
690 '
700 BCDTEMP = RTCBuff(1) ' mins (00-59)
710 GOSUB 1140
720 min$ = STR$(decimal) '
730 '
740 BCDTEMP = RTCBuff(2) ' hours (00-23) --> In military time!
750 GOSUB 1140
760 hrs$ = STR$(decimal)
770 '
780 t$ = hrs$+":"+min$+":"+sec$ ' <---- Update time
790 oldTime$ = TIME$
800 TIME$ = T$
810 '
820 BCDTEMP = RTCBuff(3) ' DOW DS3231/DS1307 RTC --> Sun(1)Mon(2)Tue(3)Wed(4)Thu(5)Fri(6)Sat(7)
830 GOSUB 1140
840 dow$ = STR$(decimal) ' No register for DOW on Pic32!
850 '
860 BCDTEMP = RTCBuff(4) ' date --> day of month (01-31)
870 GOSUB 1140
880 day$ = STR$(decimal)
890 '
900 BCDTEMP = RTCBuff(5) ' month - (01-12)
910 GOSUB 1140
920 month$ = STR$(decimal)
930 '
940 BCDTEMP = RTCBuff(6) ' year - (00-99) Needs + 2000 
950 GOSUB 1140
960 decimal = decimal + 2000 ' adjust year + 2000
970 year$ = STR$(decimal)
980 '
990 d$ = day$+"-"+month$+"-"+year$ ' <---- Update date (day/month/year + 2000)
1000 '
1010 '
1020 oldDate$ = DATE$
1030 DATE$ = d$
1040 '
1050 ? TAB(5);"Old PIC32 Time (Default) = ",oldTime$
1060 ? TAB(5);"Old PIC32 Date (Default) = ",oldDate$
1070 ? TAB(5);"New Time (From DS3231)   = ",TIME$
1080 ? TAB(5);"New Date (From DS3231)   = ",DATE$
1090 ? TAB(5);"Pause 15 secs..."
1100 PAUSE 15000
1110 GOTO 1230     
1120 END
1130 ' --- Convert BCD to Decimal -----
1140 Decimal = FIX(BCDTemp / 16) * 10
1150 Decimal = Decimal + (BCDTEMP AND &hF)
1160 RETURN
1170 '==========================================================================
1180 '                   End of PIC32 RTC boot Time Date update    
1190 '==========================================================================
1200 'Under Menu_1.bas there is a secret toggle for boot to main or boot to utility menu.
1210 'The default is boot to main "b:main_R1.bas"
1220 '
1230 OPEN "B:Boot.dat" FOR INPUT AS #9
1240 INPUT #9, key$
1250 CLOSE #9
1260 '
1270 IF Key$ = "MAIN" THEN GOTO 1330
1280 '--------Run Menu.bas--------
1290 RUN "B:menu_r1.bas"
1300 '-----------------------------
1310 '     
1320 '--------Run Main.bas--------
1330 RUN "B:main_r1.bas"
1340 '-----------------------------
1350 '

