10 '--------P_RTC_R1.bas----------------------------
20 '--------- READ DS3231 RTC Time/Date/DOW and Print DS3231 Time/Date/DOW -----
30 'Author: Hacker - DuinoMiteMegaAndy
40 'Date: 17/12/2011
50 'Version: Rev. 1.0b
60 'MMBasic Firmware: 2.7 DuinoMite Mega
70 'Platform: Win XP/SP3
80 'Credits: CrackerJack 
90 '
100 ' --------------Code Begin--------------------
110 DIM RTCbuff(8)
120 I2Caddr = &h68 ' DS3231/DS1307 I2C address (dec 104)
130 I2CEN 400,100  ' Enable I2C 400 Khz 100 ms timeout
140 I2CRCV I2Caddr, 0, 8, RTCbuff(0), 1, 0 
150 I2CDIS
160 '
170 BCDTEMP = RTCBuff(0) 'secs (00-59)
180 GOSUB 650
190 sec$ = STR$(decimal)
200 '
210 BCDTEMP = RTCBuff(1) ' mins (00-59)
220 GOSUB 650
230 MIN$ = STR$(decimal)
240 '
250 BCDTEMP = RTCBuff(2) ' hours (00-23) --> In military time!
260 GOSUB 650
270 hrs$ = STR$(decimal)
280 '
290 t$ = hrs$+":"+min$+":"+sec$ ' <---- Update time variable only
300 '
310 BCDTEMP = RTCBuff(3) 'DS3231/DS1307 RTC --> Sun(1)Mon(2)Tue(3)Wed(4)Thu(5)Fri(6)Sat(7)
320 GOSUB 650
330 DOW = decimal
340 '
350 IF DOW = 1 THEN dow$ = "Sunday    "
360 IF DOW = 2 THEN dow$ = "Monday    "
370 IF DOW = 3 THEN dow$ = "Tuesday   "
380 IF DOW = 4 THEN dow$ = "Wednesday "
390 IF DOW = 5 THEN dow$ = "Thursday  "
400 IF DOW = 6 THEN dow$ = "Friday    "
410 IF DOW = 7 THEN dow$ = "Saturday  "
420 'no error checking due to fix registers of the DS3231
430 '
440 BCDTEMP = RTCBuff(4) ' date --> day of month (01-31)
450 GOSUB 650
460 day$ = STR$(decimal)
470 '
480 BCDTEMP = RTCBuff(5) ' month - (01-12)
490 GOSUB 650
500 month$ = STR$(decimal)
510 '
520 BCDTEMP = RTCBuff(6) ' year - (00-99) Needs + 2000 
530 GOSUB 650
540 decimal = decimal + 2000 ' adjust year + 2000
550 year$ = STR$(decimal)
560 '
570 d$ = day$+":"+month$+":"+year$ ' <---- Update date variable only (day/month/year + 2000)
580 ? "DS3231 Time = ",T$           ' Print Time 
590 ? "DS3231 Date = ",D$           ' Print Date
600 ? "DS3231 DOW  = ",DOW$," ",DOW ' Print DOW$ - Day of week string and variable 
610 INPUT "Hit CR To Continue "; Query$
620 CLS
630 RUN "b:TD_R1.bas" 
640 END
650 ' --- Convert BCD to Decimal -----
660 Decimal = FIX(BCDTemp / 16) * 10
670 Decimal = Decimal + (BCDTEMP AND &hF)
680 'Decimal = Decimal + (BCDTEMP Mod 16) <--- alternate ???
690 RETURN
700 '                                         
