10 '--------ARRTC_R1.bas----------------------------
20 '--READ DS3231 RTC Time/Date and updates DuinoMite Mega PIC32 RTC -----------
30 'Author: Hacker - DuinoMiteMegaAndy
40 'Date: 17/12/2011
50 'Version: Rev. 1.0b
60 'MMBasic Firmware: 2.7 DuinoMite Mega
70 'Platform: Win XP/SP3
80 'Credits: CrackerJack 
90 '
100 ' --------------Code Begin--------------------
110 DIM RTCBuff(8)
120 I2Caddr = &h68 ' DS3231/DS1307 I2C address (dec 104)
130 I2CEN 400,100  ' Enable I2C 400 Khz 100 ms timeout 
140 I2CRCV I2Caddr, 0, 8, RTCbuff(0), 1, 0 ' 
150 I2CDIS
160 '
170 BCDTEMP = RTCBuff(0) 'secs (00-59)
180 GOSUB 650
190 sec$ = STR$(decimal)
200 '
210 BCDTEMP = RTCBuff(1) ' mins (00-59)
220 GOSUB 650
230 min$ = STR$(decimal)
240 '
250 BCDTEMP = RTCBuff(2) ' hours (00-23) --> In military time!
260 GOSUB 650
270 hrs$ = STR$(decimal)
280 '
290 t$ = hrs$+":"+min$+":"+sec$ ' <---- Update time
300 oldTime$ = TIME$
310 TIME$ = T$
320 '
330 BCDTEMP = RTCBuff(3) ' dow - day of week (1-7)  Sunday = 1
340 GOSUB 650
350 dow$ = STR$(decimal)
360 '
370 BCDTEMP = RTCBuff(4) ' date --> day of month (01-31)
380 GOSUB 650
390 day$ = STR$(decimal)
400 '
410 BCDTEMP = RTCBuff(5) ' month - (01-12)
420 GOSUB 650
430 month$ = STR$(decimal)
440 '
450 BCDTEMP = RTCBuff(6) ' year - (00-99) Needs + 2000 
460 GOSUB 650
470 decimal = decimal + 2000 ' adjust year + 2000
480 year$ = STR$(decimal)
490 '
500 d$ = day$+"-"+month$+"-"+year$ ' <---- Update date (day/month/year + 2000)
510 '
520 '
530 oldDate$ = DATE$
540 DATE$ = d$
550 CLS
560 ? "Old PIC32 Time         = ",oldTime$
570 ? "Old PIC32 Date         = ",oldDate$
580 ? "New Time (From DS3231) = ",TIME$
590 ? "New Date (From DS3231) = ",DATE$
600 INPUT "Hit CR To Continue "; Query$
610 CLS
620 RUN "b:TD_R1.bas"  
630 END
640 ' --- Convert BCD to Decimal -----
650 Decimal = FIX(BCDTemp / 16) * 10
660 Decimal = Decimal + (BCDTEMP AND &hF)
670 RETURN
680 '
     
