10 '--------Clocks_P.bas----------------------------
20 '--READ DS3231 RTC Time/Date and Print Both PIC32/DS3231 RTC Time Date ------
30 'Author: Hacker - DuinoMiteMegaAndy
40 'Date: 17/12/2011
50 'Version: Rev. 1.0b
60 'MMBasic Firmware: 2.7 DuinoMite Mega
70 'Platform: Win XP/SP3
80 'Credits: CrackerJack 
90 '
100 ' --------------Code Begin--------------------
110 DIM RTCbuff(8)
120 I2Caddr = &h68 ' DS3231/DS1307 I2C address (dec 104)
130 I2CEN 400,100  ' Enable I2C 400 Khz 100 ms timeout
140 I2CRCV I2Caddr, 0, 8, RTCbuff(0), 1, 0 
150 I2CDIS
160 '
170 BCDTEMP = RTCBuff(0) 'secs (00-59)
180 GOSUB 620
190 sec$ = STR$(decimal)
200 '
210 BCDTEMP = RTCBuff(1) ' mins (00-59)
220 GOSUB 620
230 MIN$ = STR$(decimal)
240 '
250 BCDTEMP = RTCBuff(2) ' hours (00-23) --> In military time!
260 GOSUB 620
270 hrs$ = STR$(decimal)
280 '
290 t$ = hrs$+":"+min$+":"+sec$ ' <---- Update time variable only
300 '? "hours = ", hrs$
310 '? "minutes = ",min$
320 '
330 '
340 '
350 BCDTEMP = RTCBuff(3) ' dow - day of week (1-7)  Sunday = 1
360 GOSUB 620
370 dow$ = STR$(decimal)
380 '
390 BCDTEMP = RTCBuff(4) ' date --> day of month (01-31)
400 GOSUB 620
410 day$ = STR$(decimal)
420 '
430 BCDTEMP = RTCBuff(5) ' month - (01-12)
440 GOSUB 620
450 month$ = STR$(decimal)
460 '
470 BCDTEMP = RTCBuff(6) ' year - (00-99) Needs + 2000 
480 GOSUB 620
490 decimal = decimal + 2000 ' adjust year + 2000
500 year$ = STR$(decimal)
510 '
520 d$ = day$+"-"+month$+"-"+year$ ' <---- Update date variable only (day/month/year + 2000)
530 '? "date = ", day$
540 '? "month = ", month$
550 '? "year = ", year$
560 '
570 ? "DS3231 Time: ",T$ ' Print Time 
580 ? "DS3231 Date: ",D$ ' Print Date
581 ? "PIC32  Time: ",Time$ ' Print Time
582 ? "PIC32  Date: ",Date$ ' Print Date
590 INPUT "Hit CR To Continue "; Query$
591 cls
600 RUN "b:TD_R1.bas" 
610 END
620 ' --- Convert BCD to Decimal -----
630 Decimal = FIX(BCDTemp / 16) * 10
640 Decimal = Decimal + (BCDTEMP AND &hF)
650 'Decimal = Decimal + (BCDTEMP Mod 16) <--- alternate ???
660 RETURN
670 '                                         
