10 '--------MSRTC_R1.bas----------------------------
20 '-------- Manual Set RTC DS3231/DS1307 ONLY (Not PIC32) Time/DOW/Date-------
30 'Author: Hacker - DuinoMiteMegaAndy
40 'Date: 17/12/2011
50 'Version: Rev. 1.0b
60 'MMBasic Firmware: 2.7 DuinoMite Mega
70 'Platform: Win XP/SP3
80 'Credits: CrackerJack 
90 '
100 ' --------------Code Begin--------------------
110 CLS
120 PAUSE 1000
130 INPUT "Hours (0-23)"; Hours
140 HR$ = STR$(hours)
150 PRINT TAB(4); Hours
160 INPUT "Minutes (0-59)"; Minutes
170 Min$ = STR$(Minutes)
180 PRINT TAB(4); Minutes
190 INPUT "Time OK? --> Y or N"; Query$
200 IF Query$  = "N" OR Query$  = "n" THEN CLS: GOTO 130
210 IF Query$  = "Y" OR Query$ = "y"THEN GOTO 240
220 PRINT "ABORT --> Incorrect Entry!"
230 END
240 INPUT "Day of Week [(1-7)Sun(1)Mon(2)Tue(3)Wed(4)Thur(5)Fri(6),Sat(7)]"; DOW
250 PRINT TAB(4); DOW
260 INPUT "Day (1-31)"; Day
270 Dat$ = STR$(Day)
280 PRINT TAB(4); Day
290 INPUT "Month (1-12)"; Month
300 Mon$ = STR$(Month)
310 PRINT TAB(4); Month
320 INPUT "Year (0-99)"; Year
330 YR$ = STR$(Year)
340 PRINT TAB(4); Year
350 INPUT "DOW & Date OK? --> Y or N"; Query$
360 IF Query$  = "N" OR Query$  = "n" THEN GOTO 240
370 IF Query$  = "Y" OR Query$  = "y" THEN GOTO 420
380 PRINT "ABORT --> Incorrect Entry!"
390 END
400 'Convert all time, DOW & date variables from decimal to BCD for DS3231 RTC
410  ' ------ Range check-------------
420  DecimalTemp = Hours
430  IF DecimalTemp >= 0 AND DecimalTemp <= 23 THEN GOTO 480
440  PRINT "ABORT --> Hours Out Of Range!"
450  END 
460  '
470  '
480  GOSUB 1180
490  BCD_Hours = BCD
500 ' ------ Range check------------------
510  DecimalTemp = Minutes
520  IF DecimalTemp >= 0 AND DecimalTemp <= 59 THEN GOTO  570 
530  PRINT "ABORT --> Minutes Out Of Range!"
540  END
550  '
560  '
570  GOSUB 1180
580  BCD_Minutes = BCD
590  '  ------ Range check------------------
600  DecimalTemp = DOW
610  IF DecimalTemp >= 1 AND DecimalTemp <= 7 THEN GOTO  660 
620  PRINT "ABORT --> DOW Out Of Range!"
630  END
640  '
650  '
660  GOSUB 1180
670  BCD_DOW = BCD
680  ' ------ Range check------------------
690  DecimalTemp = Day
700  IF DecimalTemp >= 1 AND DecimalTemp <= 31 THEN GOTO  750
710  PRINT "ABORT --> Date Out Of Range!"
720  END
730  '
740  '
750  GOSUB 1180
760  BCD_Day = BCD
770 ' ------ Range check------------------
780  DecimalTemp = Month
790  IF DecimalTemp >= 1 AND DecimalTemp <= 12 THEN GOTO 840
800  PRINT "ABORT --> Month Out Of Range!"
810  END
820  '
830  '
840  GOSUB 1180
850  BCD_Month = BCD
860 ' ------ Range check------------------
870  DecimalTemp = Year
880  IF DecimalTemp >= 0 AND DecimalTemp <= 99 THEN GOTO  930
890  PRINT "ABORT --> Year Out Of Range!"
900  END
910  '
920  '
930  GOSUB 1180
940  BCD_Year = BCD
950 '
960 INPUT "Wait For Exact Seconds Rollover To 0 And Hit CR To Set DS3231 Time & Date ...", Query$
970 '
980 rtcctrl = &h10
990 BCD_DOW = &h1
1000 BCD_Seconds = &h0
1010 temp = 0
1020 Sec$ = STR$(temp)
1030 '
1040 I2Caddr = &h68 ' DS3231/DS1307 I2C address (dec 104)
1050 I2CEN 400,100  ' Enable I2C 400 Khz 100 ms timeout  
1060 I2CSEND I2Caddr, 0, 8, &h0, BCD_Seconds,BCD_Minutes,BCD_Hours,BCD_DOW,BCD_Day,BCD_Month,BCD_Year
1070 I2CDIS
1080 '
1090 ? "0=ok 1=nack 2=timeout"; MM.I2C
1100 SentDate$ = dat$+"-"+Mon$+"-"+Yr$
1110 SentTime$ = hr$+":"+min$+":"+sec$
1120 ? "DS3231 RTC Time/Date Has Been Set To ... ";SentTime$;" ";SentDate$
1130 INPUT "Hit CR To Continue "; Query$ 
1140 CLS
1150 RUN "B:TD_R1.BAS" ' Back to Time Date utility menu 
1160 END
1170 ' -----GOSUB Convert Decimal to BCD HEX --------------
1180 BCD = FIX(DecimalTemp / 10) * 16
1190 BCD = BCD OR ((DecimalTemp / 10) - (FIX(DecimalTemp / 10))) * 10
1200 RETURN
1210 '  
