10 '--------PIC32DOW.bas----------------------------
20 '--------Read PIC32 Date and Calculate/Print DOW - Day of Week-------
30 'Author: Hacker - DuinoMiteMegaAndy
40 'Date: 17/12/2011
50 'Version: Rev. 1.0b
60 'MMBasic Firmware: 2.7 DuinoMite Mega
70 'Platform: Win XP/SP3
80 ' 
90 '
100 ' --------------Code Begin--------------------
110 'Get date from PIC32 date$ 
120 day = VAL(LEFT$(DATE$, 2)) 
130 month = VAL(MID$(DATE$, 4, 2))
140 year = (VAL(RIGHT$(DATE$, 4)) - 2000)
150 a = (14 - month) / 12
160 a = FIX(a)
170 y = year - a
180 y = FIX(y)
190 m = month + (12 * a) - 2
200 m = FIX(m)
210 d = ((day + y) + FIX(y / 4) - FIX(y / 100) + FIX(y / 400) + FIX((31 * m) / 12)) 
220 DOW = d MOD 7
230 DOW = DOW + 1 ' offset for DS3231/DS1307 RTC --> Sun(1)Mon(2)Tue(3)Wed(4)Thu(5)Fri(6)Sat(7)
240 IF DOW = 1 THEN ? "PIC32 Calculated DOW = 1 = Sunday    ":dow$ = "Sunday    ": GOTO 320
250 IF DOW = 2 THEN ? "PIC32 Calculated DOW = 2 = Monday    ":dow$ = "Monday    ": GOTO 320
260 IF DOW = 3 THEN ? "PIC32 Calculated DOW = 3 = Tuesday   ":dow$ = "Tuesday   ": GOTO 320
270 IF DOW = 4 THEN ? "PIC32 Calculated DOW = 4 = Wednesday ":dow$ = "Wednesday ": GOTO 320
280 IF DOW = 5 THEN ? "PIC32 Calculated DOW = 5 = Thursday  ":dow$ = "Thursday  ": GOTO 320
290 IF DOW = 6 THEN ? "PIC32 Calculated DOW = 6 = Friday    ":dow$ = "Friday    ": GOTO 320
300 IF DOW = 7 THEN ? "PIC32 Calculated DOW = 7 = Saturday  ":dow$ = "Saturday  ": GOTO 320
310 ? "ABORT ---> DOW Not Found! ":END
320 INPUT "Hit CR To Continue "; Query$ 
330 CLS
340 RUN "B:TD_R1.bas"
350 '  
