10 '--------PIC32DOY.bas----------------------------
20 '--------Read PIC32 Date and Calculate/Print DOY - Day of Year-------
30 'Author: Hacker - DuinoMiteMegaAndy
40 'Date: 17/12/2011
50 'Version: Rev. 1.0b
60 'MMBasic Firmware: 2.7 DuinoMite Mega
70 'Platform: Win XP/SP3
80 ' 
90 '
100 ' --------------Code Begin--------------------
110 'Get date from PIC32 date$ 
120 day = VAL(LEFT$(DATE$, 2)) 
130 month = VAL(MID$(DATE$, 4, 2))
140 year = (VAL(RIGHT$(DATE$, 4)) - 2000)
150 N1 = INT(275 * Month / 9)
160 N2 = INT((month + 9)/12)
170 N3 = (1 + INT((year -4 * INT(YEAR/4) +2) / 3))
180 N = N1 - (N2 * N3) + day - 30
190 DOY = N
200 ? "Day Of Year ",DOY
210 INPUT "Hit CR To Continue "; Query$ 
220 CLS
230 RUN "B:TD_R1.bas"
240 '  
